"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("babel-polyfill");

var _chalk = _interopRequireDefault(require("chalk"));

var _chokidar = _interopRequireDefault(require("chokidar"));

var _s2sHookPrettier = _interopRequireDefault(require("s2s-hook-prettier"));

var _handlers = _interopRequireDefault(require("./handlers"));

var _templates = _interopRequireDefault(require("./templates"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function createWatcher(rootPath, ignored) {
  const watcher = _chokidar.default.watch(rootPath, {
    cwd: process.cwd(),
    ignoreInitial: true,
    ignored
  });

  return watcher;
}

var _default = inputConfg => {
  const config = _objectSpread({}, {
    watch: './**/*.js',
    plugins: [],
    templates: [],
    afterHooks: [],
    prettier: true,
    ignored: ['.git/', 'node_modules/']
  }, inputConfg);

  const {
    watch,
    plugins,
    templates,
    afterHooks,
    ignored
  } = config;

  if (!watch) {
    throw new Error('required watch');
  }

  if (!Array.isArray(plugins)) {
    throw new TypeError(`Expected a Array, got ${typeof plugins}`);
  }

  if (!Array.isArray(templates)) {
    throw new TypeError(`Expected a Array got ${typeof templates}`);
  }

  if (!Array.isArray(afterHooks)) {
    throw new TypeError(`Expected a Array got ${typeof afterHooks}`);
  }

  const watcher = createWatcher(watch, ignored);

  if (config.prettier) {
    afterHooks.push((0, _s2sHookPrettier.default)());
  }

  if (plugins.length > 0) {
    for (const type of ['add', 'change', 'unlink']) {
      watcher.on(type, input => {
        (0, _handlers.default)(input, type, config);
      });
    }
  }

  if (templates.length > 0) {
    for (const type of ['add', 'addDir']) {
      watcher.on(type, input => {
        (0, _templates.default)(input, templates, config.templatesDir);
      });
    }
  }

  const msg = `${_chalk.default.bold('s2s')} started monitoring. Enjoy coding with ${_chalk.default.bold('s2s')}.`;
  console.log(msg);
  return watcher;
};

exports.default = _default;